;;; $Id: 3-6-letrec1.scm,v 1.6 2005/03/24 19:51:40 leavens Exp $
;;; environment structure for letrec, using procedural representation

(let ((time-stamp "Time-stamp: <2000-09-07 07:26:52 dfried>"))
  (eopl:printf "letrec1.scm -- procedural rep of environments ~a~%"
    (substring time-stamp 13 29)))

;;;;;;;;;;;;;;;; environments ;;;;;;;;;;;;;;;;

;; This can't be a module, because it uses procval->expressed, closure, etc.

;; type predicate
(deftype environment? (type-predicate-for environment))

;; constructors
(deftype empty-env (-> () environment))
(deftype extend-env
  (-> ((list-of symbol) (list-of Expressed-Value) environment) environment))
(deftype extend-env-recursively            ; for section 3.6
  (-> ((list-of symbol) (list-of (list-of symbol)) (list-of expression)
       environment)
      environment))

;; observers
(deftype apply-env
  (-> (environment symbol) Expressed-Value))
(deftype defined-in-env?                   ; added
  (-> (environment symbol) boolean))

(require (lib "list-index-find.scm" "lib342"))

; (defrep (environment (-> (symbol) Expressed-Value)))

(define environment? procedure?)

(define apply-env
  (lambda (env sym)
    (env sym)))

(define empty-env
  (lambda ()
    (lambda (sym)
      (eopl:error 'empty-env "No binding for: ~s" sym))))

(define extend-env
  (lambda (ids vals env)
    (lambda (sym)
      (let ((pos (list-index sym ids)))
        (if (<= 0 pos)
          (list-ref vals pos)
          (apply-env env sym))))))

(define extend-env-recursively
  (lambda (proc-names idss bodies old-env)
    (letrec
	((rec-env
	  (lambda (sym)
	    (let ((pos (list-index sym proc-names)))
	      (if (<= 0 pos)
		  (procval->expressed
		   (closure
		    (list-ref idss pos)
		    (list-ref bodies pos)
		    rec-env))
		  (apply-env old-env sym))))))
      rec-env)))
