;;; $Id: 3-6-letrec2.scm,v 1.7 2005/05/03 20:36:05 leavens Exp $
;;; environment structure for letrec, using AST with new rib type

(let ((time-stamp "Time-stamp: <2000-09-07 07:27:43 dfried>"))
  (eopl:printf
    "letrec2.scm -- AST rep of environments with 2 kinds of ribs ~a~%"
    (substring time-stamp 13 29)))

;;;;;;;;;;;;;;;; environments ;;;;;;;;;;;;;;;;

;; This can't be a module, because it uses procval->expressed, closure, etc.

;; type predicate
(deftype environment? (type-predicate-for environment))

;; constructors
(deftype empty-env (-> () environment))
(deftype extend-env
  (-> ((list-of symbol) (list-of Expressed-Value) environment) environment))
(deftype extend-env-recursively            ; for section 3.6
  (-> ((list-of symbol) (list-of (list-of symbol)) (list-of expression)
       environment)
      environment))

;; observers
(deftype apply-env
  (-> (environment symbol) Expressed-Value))
(deftype defined-in-env?                   ; added
  (-> (environment symbol) boolean))

(require (lib "list-index-find.scm" "lib342"))

(define-datatype environment environment? 
  (empty-env)             
  (extended-env-record
    (syms (list-of symbol?))
    (vals vector?)
    (env environment?))
  (extend-env-recursively
    (proc-names (list-of symbol?))
    (idss (list-of (list-of symbol?)))
    (bodies (list-of expression?))
    (env environment?)))

(define extend-env
  (lambda (syms val-list env)
    (extended-env-record syms (list->vector val-list) env)))

(define apply-env
  (lambda (env sym)
    (cases environment env
      (empty-env ()
        (eopl:error 'empty-env "No binding for ~s" sym))
      (extended-env-record (syms vals old-env)
        (let ((pos (list-index sym syms)))
          (if (<= 0 pos)
            (vector-ref vals pos)
            (apply-env old-env sym))))
      (extend-env-recursively (proc-names idss bodies old-env) 
        (let ((pos (list-index sym proc-names)))
          (if (<= 0 pos)
            (procval->expressed
	     (closure
              (list-ref idss pos)
              (list-ref bodies pos)
              env))
            (apply-env old-env sym)))))))

