;;; $Id: combinators.scm,v 1.6 2002/04/09 22:25:24 leavens Exp $
;;; AUTHOR: Gary T. Leavens

trustme!  ;; lots of this file cannot be type checked for fundamental reasons

(deftype I (forall (T) (-> (T) T)))
(define I
  (lambda (x) x))

(deftype K (forall (S T) (-> (T) (-> (S) T))))
(define K
  (lambda (x)
    (lambda (y) x)))

;;; The type for S isn't as polymorphic as it should be,
;;; but the type system used here doesn't allow it's true type to be expressed.
(deftype S
  (forall (S T U) (-> ((-> (T) (-> (S) U))) (-> ((-> (T) S)) (-> (T) U)))))
(define S
  (lambda (x)
    (lambda (y)
      (lambda (z)
	((x z) (y z))))))

;; the following is the type B would have if S had the right type
(deftype B (forall (S T U) (-> ((-> (S) U)) (-> ((-> (T) S)) (-> (T) U)))))
(define B
  ((S (K S)) K))

;; the type of zero can't be inferred...
(deftype zero (forall (S T U) (-> ((-> (S) U)) (-> (T) T))))
(define zero
  (K I))

(deftype add1
  (forall (S T U)
     (-> ((-> ((-> (S) U)) (-> (T) S))) (-> ((-> (S) U)) (-> (T) U)))))
(define add1
  (S B))

;; the type of D can't be inferred...
(define D
  ;; EQUATIONS: (((D X) Y) zero) = X
  ;;            (((D X) Y) (add1 Z)) = Y
  ((S (K (S ((S (K S)) ((S (K (S I))) ((S (K K)) K)))))) ((S (K K)) K)))
