;;; $Id: double-size.scm,v 1.1 2005/02/06 04:33:18 leavens Exp $
;;; AUTHOR: Gary T. Leavens

(load "window-layout.scm")

(deftype double-size (-> (window-layout) window-layout))
(define double-size
  (lambda (layout)
    ;; ENSURES: result is the same as layout, but with all sizes doubled
    (cond
       ((window? layout) (window (window->name layout)
                                 (* 2 (window->width layout))
                                 (* 2 (window->height layout))))
       ((horizontal? layout)
        (horizontal (map (lambda (w) (double-size w))
                                (horizontal->subwindows layout))))
       (else ;; vertical case
         (vertical (map (lambda (w) (double-size w))
                              (vertical->subwindows layout)))))))
