;;; $Id: environment-as-proc.scm,v 1.5 2005/03/21 21:58:37 leavens Exp $

;;; Adapted from EOPL2e, Figure 2.3, p. 57

(module environment-as-proc (lib "typedscm.ss" "lib342")

(provide empty-env extend-env apply-env)

(deftype empty-env
  (-> () environment))
(deftype extend-env
  (-> ((list-of symbol) (list-of datum) environment) environment))
(deftype apply-env
  (-> (environment symbol) datum))

(require (lib "list-index-find.scm" "lib342"))

(defrep (environment (-> (symbol) datum)))

(define empty-env
  (lambda ()
    (lambda (sym) 
      (eopl:error 'apply-env "No binding for ~s" sym))))

(define extend-env
  (lambda (syms vals env)
    (lambda (sym)
      (let ((pos (list-index sym syms)))
        (if (<= 0 pos)
          (list-ref vals pos)
          (apply-env env sym))))))

(define apply-env
  (lambda (env sym) 
    (env sym)))

) ;; end module
