;;; $Id: environment-as-ribcage.scm,v 1.6 2005/03/21 21:58:37 leavens Exp $
;;; adapted from 3-5.scm in the EOPL2e distribution

;;;;;;;;;;;;;;;; environments ;;;;;;;;;;;;;;;;

(module environment-as-ribcage (lib "typedscm.ss" "lib342")

(provide environment? empty-env extend-env apply-env defined-in-env?)

;; type predicate
(deftype environment? (type-predicate-for environment))

;; constructors
(deftype empty-env (-> () environment))
(deftype extend-env
  (-> ((list-of symbol) (list-of Expressed-Value) environment) environment))

;; observers
(deftype apply-env
  (-> (environment symbol) Expressed-Value))
(deftype defined-in-env?                   ; added
  (-> (environment symbol) boolean))

(require (lib "list-index-find.scm" "lib342"))

(define-datatype environment environment?
  (empty-env)
  (extended-env-record
    (syms (list-of symbol?))
    (vec vector?)              ; can use this for anything.
    (env environment?))
  )

(define extend-env
  (lambda (syms vals env)
    ;; ENSURES: result is an extended-env-record that corresponds
    ;;          to this constructor call, with a vector containing
    ;;          the values instead of the list passed in.
    (extended-env-record syms (list->vector vals) env)))

(define apply-env
  (lambda (env sym)
    (cases environment env
      (empty-env ()
        (eopl:error 'apply-env "No binding for ~s" sym))
      (extended-env-record (syms vals env)
        (let ((position (list-index sym syms)))
          (if (<= 0 position)
              (vector-ref vals position)
              (apply-env env sym)))))))

(define defined-in-env?
  (lambda (env sym)
    (cases environment env
      (empty-env () #f)
      (extended-env-record (syms vals env)
        (let ((position (list-index sym syms)))
          (or (<= 0 position)
              (defined-in-env? env sym)))))))

) ;; end module
