;; $Id: lambda-1-exp-examples.tst,v 1.1 2002/04/09 22:25:24 leavens Exp $

(load-quietly "lambda-1-exp-examples.scm")

(define lexp1 (parse-lambda-1-exp '(lambda (x) (f x))))
(define lexp2 (lambda-exp 'z (app-exp lexp1
				      (parse-lambda-1-exp '(g (h y))))))
(define lexp3 (lambda-exp 'f lexp2))
(define lexp4 (app-exp lexp3 (parse-lambda-1-exp
			      '(car (cdr (x (y z)))))))
(define lexp5 (lambda-exp 'y lexp4))
(define lexp6 (lambda-exp 'f lexp4))
(define lexp7 (app-exp lexp5 lexp2))

(run-regression-tests-equal?
 `(
    ( (count-var-exps (var-exp 'x)) ==> 1 )
    ( (count-var-exps (app-exp (var-exp 'x) (var-exp 'y))) ==> 2 )
    ( (count-var-exps (parse-lambda-1-exp '(x y))) ==> 2 )
    ( (count-var-exps (parse-lambda-1-exp '(lambda (x) x))) ==> 1 )
    ( (count-var-exps (parse-lambda-1-exp '(f (lambda (x) x)))) ==> 2 )

    ( (all-var-exps (parse-lambda-1-exp 'x)) ==> (x) )
    ( (all-var-exps (parse-lambda-1-exp '(x y))) ==> (x y) )
    ( (all-var-exps (parse-lambda-1-exp '(lambda (x) y))) ==> (y) )
    ( (all-var-exps (parse-lambda-1-exp '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

   ( (free-vars (parse-lambda-1-exp 'x)) ==> (x) )
   ( (free-vars (parse-lambda-1-exp '(x y))) ==> (x y) )
   ( (free-vars (parse-lambda-1-exp ',lexp1)) ==> (f) )
   ( (free-vars (parse-lambda-1-exp ',lexp2))
     ==> (f g h y) )
   ( (free-vars (parse-lambda-1-exp ',lexp3))
     ==> (g h y) )
   ( (free-vars (parse-lambda-1-exp ',lexp4))
     ==> (g h y car cdr x y z) )
   ( (free-vars (parse-lambda-1-exp ',lexp5))
     ==> (g h car cdr x z) )
   ( (free-vars (parse-lambda-1-exp ',lexp6))
     ==> (g h y car cdr x y z) )
   ( (free-vars (parse-lambda-1-exp ',lexp7))
     ==> (g h car cdr x z f g h y) )
   ( (free-vars (parse-lambda-1-exp '((lambda (y) y) (lambda (x) (y x)))))
     ==> (y) )

   ( (free? 'x (parse-lambda-1-exp 'x))      ==> #t )
   ( (free? 'x (parse-lambda-1-exp 'y))      ==> #f )
   ( (free? 'x (parse-lambda-1-exp '(x y)))  ==> #t )
   ( (free? 'g (parse-lambda-1-exp ',lexp1)) ==> #f )
   ( (free? 'f (parse-lambda-1-exp ',lexp2)) ==> #t )
   ( (free? 'f (parse-lambda-1-exp ',lexp3)) ==> #f )
   ( (free? 'x (parse-lambda-1-exp ',lexp4)) ==> #t )
   ( (free? 'z (parse-lambda-1-exp ',lexp5)) ==> #t )
   ( (free? 'y (parse-lambda-1-exp ',lexp6)) ==> #t )
   ( (free? 'y (parse-lambda-1-exp ',lexp7)) ==> #t )
   
   ( (bound-vars (parse-lambda-1-exp 'x)) ==> () )
   ( (bound-vars (parse-lambda-1-exp '(x y))) ==> () )
   ( (bound-vars (parse-lambda-1-exp '(lambda (x) (lambda (x) y))))
     ==> () )
   ( (bound-vars (parse-lambda-1-exp ',lexp1)) ==> (x) )
   ( (bound-vars (parse-lambda-1-exp ',lexp2)) ==> (x) )
   ( (bound-vars (parse-lambda-1-exp ',lexp3)) ==> (f x) )
   ( (bound-vars (parse-lambda-1-exp ',lexp4)) ==> (f x) )
   ( (bound-vars (parse-lambda-1-exp ',lexp5)) ==> (y f x) )
   ( (bound-vars (parse-lambda-1-exp ',lexp6)) ==> (f x) )
   ( (bound-vars (parse-lambda-1-exp ',lexp7)) ==> (y f x x) )

   ( (bound? 'x (parse-lambda-1-exp 'x))      ==> #f )
   ( (bound? 'x (parse-lambda-1-exp '(x y)))  ==> #f )
   ( (bound? 'g (parse-lambda-1-exp ',lexp1)) ==> #f )
   ( (bound? 'f (parse-lambda-1-exp ',lexp2)) ==> #f )
   ( (bound? 'f (parse-lambda-1-exp ',lexp3)) ==> #t )
   ( (bound? 'x (parse-lambda-1-exp ',lexp4)) ==> #t )
   ( (bound? 'z (parse-lambda-1-exp ',lexp5)) ==> #f )
   ( (bound? 'y (parse-lambda-1-exp ',lexp6)) ==> #f )
   ( (bound? 'y (parse-lambda-1-exp ',lexp7)) ==> #t )
    )
 )

