;;; $Id: lambda-1-exp.tst,v 1.2 2005/02/18 02:39:10 leavens Exp $

(require (lib "lambda-1-exp.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (lambda-1-exp? (var-exp 'x)) ==> #t )
    ( (lambda-1-exp? (lambda-exp 'x (app-exp (var-exp 'f) (var-exp 'x))))
      ==> #t )

    ( (var-exp? (var-exp 'x))
      ==> #t )
    ( (lambda-exp? (var-exp 'x))
      ==> #f )
    ( (app-exp? (var-exp 'x))
      ==> #f )

    ( (var-exp? (lambda-exp 'x (var-exp 'x)))
      ==> #f )
    ( (lambda-exp? (lambda-exp 'x (var-exp 'x)))
      ==> #t )
    ( (app-exp? (lambda-exp 'x (var-exp 'x)))
      ==> #f )

    ( (var-exp? (app-exp (var-exp 'x) (var-exp 'z)))
      ==> #f )
    ( (lambda-exp? (app-exp (var-exp 'x) (var-exp 'z)))
      ==> #f )
    ( (app-exp? (app-exp (var-exp 'x) (var-exp 'z)))
      ==> #t )

    ( (var-exp->id (var-exp 'x)) ==> x )

    ( (lambda-exp->id (lambda-exp 'x (var-exp 'y)))  ==> x )

    ( (lambda-exp->body (lambda-exp 'x (var-exp 'y)))
      = (var-exp 'y) )

    ( (app-exp->rator (app-exp (var-exp 'x) (var-exp 'y)))
      = (var-exp 'x) )

    ( (app-exp->rand (app-exp (var-exp 'x) (var-exp 'y)))
      = (var-exp 'y) )

    ( (parse-lambda-1-exp
       '((lambda (x) (f x)) z))
      = (app-exp 
	 (lambda-exp 'x (app-exp (var-exp 'f) (var-exp 'x)))
	 (var-exp 'z)) )
    )
 )

