;; $Id: lambda-1-quote-exp-examples.tst,v 1.1 2005/02/16 11:20:05 leavens Exp $

(load "lambda-1-quote-exp-examples.scm")

(run-regression-tests-equal?
 `(
    ( (quote-exp->symbol (quote-exp 'z)) ==> z )

    ( (count-var-exps (var-exp 'x)) ==> 1 )
    ( (count-var-exps (quote-exp 'z)) ==> 0 )
    ( (count-var-exps (app-exp (var-exp 'x) (var-exp 'y))) ==> 2 )
    ( (count-var-exps (parse-lambda-1-quote-exp '(x y))) ==> 2 )
    ( (count-var-exps (parse-lambda-1-quote-exp '(lambda (x) x))) ==> 1 )
    ( (count-var-exps (parse-lambda-1-quote-exp '((lambda (x) x) (quote z))))
      ==> 1 )
    ( (count-var-exps (parse-lambda-1-quote-exp '((lambda (x) x) 'z))) ==> 1 )
    ( (count-var-exps (parse-lambda-1-quote-exp '(f (lambda (x) x)))) ==> 2 )

    ( (all-var-exps (parse-lambda-1-quote-exp 'x)) ==> (x) )
    ( (all-var-exps (parse-lambda-1-quote-exp '(quote z))) ==> () )
    ( (all-var-exps (parse-lambda-1-quote-exp '(x y))) ==> (x y) )
    ( (all-var-exps (parse-lambda-1-quote-exp '(lambda (x) y))) ==> (y) )
    ( (all-var-exps (parse-lambda-1-quote-exp '((lambda (x) x) (quote z))))
      ==> (x) )
    ( (all-var-exps (parse-lambda-1-quote-exp '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

    ( (subst-var-exps 'new 'old (parse-lambda-1-quote-exp 'old))
      ==> new )
    ( (subst-var-exps 'n 'o (parse-lambda-1-quote-exp '(quote z)))
      ==> (quote z) )
    ( (subst-var-exps 'y 'x (parse-lambda-1-quote-exp '(x y)))
      ==> (y y) )
    ( (subst-var-exps 'y 'x (parse-lambda-1-quote-exp '(lambda (x) y)))
      ==> (lambda (x) y) )
    ( (subst-var-exps 'y 'x (parse-lambda-1-quote-exp '((lambda (x) x) (quote z))))
      ==> ((lambda (x) y) (quote z)) )
    ( (subst-var-exps 'y 'x (parse-lambda-1-quote-exp '(f (lambda (x) (x (f x))))))
      ==> (f (lambda (x) (y (f y)))) )
    )
 )

