;; $Id: lambda-if-exp-examples.tst,v 1.1 2005/02/17 17:37:44 leavens Exp $

(load-from-lib "lambda-if-exp-examples.scm")

(run-regression-tests-equal?
 `(
    ( (count-var-exps (var-exp 'x)) ==> 1 )
    ( (count-var-exps (quote-exp 'z)) ==> 0 )
    ( (count-var-exps (if-exp (var-exp 'b)
			      (var-exp 'c)
			      (var-exp 'a))) ==> 3 )
    ( (count-var-exps (app-exp (var-exp 'x) (list (var-exp 'y)))) ==> 2 )
    ( (count-var-exps (parse-lambda-if-exp '(if b c a))) ==> 3 )
    ( (count-var-exps (parse-lambda-if-exp '(x y))) ==> 2 )
    ( (count-var-exps (parse-lambda-if-exp '(lambda (x) x))) ==> 1 )
    ( (count-var-exps (parse-lambda-if-exp '((lambda (x) x) (quote z))))
      ==> 1 )
    ( (count-var-exps (parse-lambda-if-exp '((lambda (x) x) 'z))) ==> 1 )
    ( (count-var-exps (parse-lambda-if-exp '(f (lambda (x) x)))) ==> 2 )

    ( (all-var-exps (parse-lambda-if-exp 'x)) ==> (x) )
    ( (all-var-exps (parse-lambda-if-exp '(quote z))) ==> () )
    ( (all-var-exps (parse-lambda-if-exp '(if b c a))) ==> (b c a) )
    ( (all-var-exps (parse-lambda-if-exp '(x y))) ==> (x y) )
    ( (all-var-exps (parse-lambda-if-exp '(lambda (x) y))) ==> (y) )
    ( (all-var-exps (parse-lambda-if-exp
		    '(if b (lambda (z) c) (lambda () (f x y)))))
      ==> (b c f x y) )
    ( (all-var-exps (parse-lambda-if-exp '((lambda (x) x) (quote z))))
      ==> (x) )
    ( (all-var-exps (parse-lambda-if-exp '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

    ( (subst-var-exps 'new 'old (parse-lambda-if-exp 'old))
      ==> new )
    ( (subst-var-exps 'n 'o (parse-lambda-if-exp '(quote z)))
      ==> (quote z) )
    ( (subst-var-exps 'y 'x (parse-lambda-if-exp '(x y)))
      ==> (y y) )
    ( (subst-var-exps 'y 'x (parse-lambda-if-exp '(lambda (x) y)))
      ==> (lambda (x) y) )
    ( (subst-var-exps 'y 'x (parse-lambda-if-exp '((lambda (x) x) (quote z))))
      ==> ((lambda (x) y) (quote z)) )
    ( (subst-var-exps 'y 'x (parse-lambda-if-exp '(f (lambda (x) (x (f x))))))
      ==> (f (lambda (x) (y (f y)))) )
    ( (subst-var-exps 'y 'x
		     (parse-lambda-if-exp
		      '(if b (lambda (x) c) (lambda () (f x y)))))
      ==> (if b (lambda (x) c) (lambda () (f y y))) )
    )
 )
