;;; $Id: load-from-lib.scm,v 1.9 2005/02/17 16:29:22 leavens Exp $

(module load-from-lib mzscheme
  (provide load-from-lib load-quietly-from-lib
           load-loudly load-quietly)
  (require (lib "localize.scm" "lib342"))
  
  ;;; save the standard load procedure
  (define std:load
    (lambda (s)
      (load s)))
  
  ;; (deftype load-from-lib-c (-> ((-> (string) void)) (-> (file-name) void)))
  (define load-from-lib-c
    (lambda (informer)
      (lambda (fn)
        ;; EFFECT: load the file named fn found in libdir,
        ;;         calling informer to tell anyone who cares about it.
        (let ((fullname (string-append *cs342:libdir* fn)))
          (informer fullname)
          (std:load fullname)))))
  
  (define loud-load-informer
    (lambda (s) (display "loading ") (display s) (display " ...") (newline)))
  
  (define silent-load-informer
    (lambda (s) (display "")))
  
  (define load-from-lib
    (lambda (s)
      ((load-from-lib-c loud-load-informer) s)))
  
  (define load-quietly-from-lib
    (lambda (s)
      ((load-from-lib-c silent-load-informer) s)))
  
  (define load-from-lib-if-not-here-c
    (lambda (informer)
      (lambda (fn)
        (cond
          ((file-exists? fn) (informer fn) (std:load fn))
          (else ((load-from-lib-c informer) fn))))))
  
  (define load-from-lib-if-not-here
    (lambda (s)
      ((load-from-lib-if-not-here-c loud-load-informer) s)))
  
  (define load-loudly
    (lambda (s)
      (load-from-lib-if-not-here s)))

  (define load-quietly-from-lib-if-not-here
    (lambda (s)
      ((load-from-lib-if-not-here-c silent-load-informer) s)))
  
  (define load-quietly
    (lambda (s)
      (load-quietly-from-lib-if-not-here s)))
  )
