;;;---------------------------------------------------------------------
;;; An ADT for a simple phone book
;;;---------------------------------------------------------------------

;;;---------------------------------------------------------------------
;;; The declarations for the public (client-visible) interface of the
;;; phone book ADT
;;;---------------------------------------------------------------------

(module phone-book-as-ast (lib "typedscm.ss" "lib342")

(provide create-empty-phone-book add-to-phone-book look-up)

(deftype create-empty-phone-book (-> () phone-book))
(deftype add-to-phone-book (-> (symbol number phone-book) phone-book))
(deftype look-up (-> (phone-book symbol) number))

;;;---------------------------------------------------------------------
;;; An AST implementation of the phone book ADT
;;;---------------------------------------------------------------------

(define-datatype phone-book phone-book?
  (create-empty-phone-book)
  (add-to-phone-book (name symbol?)
		     (number number?)
		     (old-book phone-book?)))

(define look-up
  (lambda (book who)
    (cases phone-book book
      (create-empty-phone-book () (error "no listing for" who))
      (add-to-phone-book (name number old-book)
	 (if (eq? who name)
	     number
	     (look-up old-book who)))
      (else (error "not a valid phone book" book)))))

) ;; end module
