;; $Id: ratl.scm,v 1.1 2005/03/28 17:04:51 leavens Exp $

(module ratl typedscm
  (provide make-ratl numr denr)

  (deftype make-ratl (-> (number number) ratl))
  (deftype numr (-> (ratl) number))
  (deftype denr (-> (ratl) number))

  (defrep (ratl (list-of number)))

  ;;; the following is from p. 91 of [Springer-Friedman89]

  (define make-ratl
    (lambda (int1 int2)
      (if (zero? int2)
          (error "make-ratl: The denominator cannot be zero.")
          (list int1 int2))))

  (define numr
    (lambda (rtl)
      (car rtl)))

  (define denr
    (lambda (rtl)
      (cadr rtl)))
)
