;;; $Id: road-map-as-proc.scm,v 1.6 2005/03/04 00:28:04 leavens Exp $

;;; The road-map abstraction is a concrete version of undirected graphs.
;;; Think of roads as things that cars drive on...

(module road-map-as-proc (lib "typedscm.ss" "lib342")

(provide bare-earth build-road roads-from
	;; all-from set-ops-as-vector.scm
	the-empty-set set-empty? set-size set set-member?
	set-one-elem set-rest set-subset? set-equal? set-add set-remove
	set-union set-minus set-intersect set-union-list set-union*)

(deftype bare-earth (-> () road-map))
(deftype build-road (-> (symbol symbol road-map) road-map))
(deftype roads-from (-> (road-map symbol) (set-of symbol)))

(require (lib "set-ops-as-vector.scm" "lib342"))

(defrep (road-map (-> (symbol) (set-of symbol))))

(define bare-earth
  (lambda ()
    (lambda (place)
      the-empty-set)))

(define build-road
  (lambda (from to old-map)
    (lambda (place)
        (cond
	 ((eq? place from) (set-add to (roads-from old-map place)))
	 ((eq? place to) (set-add from (roads-from old-map place)))
	 (else (roads-from old-map place))))))

(define roads-from
  (lambda (rmap place)
    (rmap place)))

) ;; end module
