;;; $Id: separate.scm,v 1.2 2005/02/17 16:29:22 leavens Exp $

(module separate (lib "typedscm.ss" "lib342")

  (provide separate-c comma-separate blank-separate
	   semicolon-separate binding-separate)
  
  (deftype separate-c (-> (string) (-> ((list-of string)) string)))
  (define separate-c
    (lambda (sep)
      (lambda (args)
	(cond
	 ((null? args) "")
	 ((null? (cdr args)) (car args))
	 (else (string-append (car args)
			      sep
			      ((separate-c sep) (cdr args))))))))

  (define comma-separate (lambda (args) ((separate-c ", ") args)))
  (define blank-separate (lambda (args) ((separate-c " ") args)))
  (define semicolon-separate (lambda (args) ((separate-c "; ") args)))
  (define binding-separate (lambda (args) ((separate-c "  ") args)))

) ;; end module
