;;; $Id: set-equal.scm,v 1.16 2005/02/17 16:29:22 leavens Exp $

;;; tests for comparing homework answer sets based on equal?
;;; Author: Gary T. Leavens

(module set-equal (lib "typedscm.ss" "lib342")
(provide cs342:set-one-elem cs342:set-rest cs342:set-empty?
	cs342:set-member? cs342:set-equal? cs342:left-protected-set-equal?
	cs342:no-duplicates? cs342:set? cs342:set)

(deftype cs342:set-one-elem (forall (T) (-> ((set-of T)) T)))
(deftype cs342:set-rest (forall (T) (-> ((set-of T)) (set-of T))))
(deftype cs342:set-empty? (forall (T) (-> ((set-of T)) boolean)))
(deftype cs342:set-member? (forall (T) (-> (T (set-of T)) boolean)))
(deftype cs342:set-equal? (forall (T) (-> ((set-of T) (set-of T)) boolean)))
(deftype cs342:left-protected-set-equal?
  (forall (T) (-> (datum (set-of T)) boolean)))
(deftype cs342:no-duplicates? (forall (T) (-> ((list-of T)) boolean)))
(deftype cs342:set? (type-predicate-for (set-of datum)))
(deftype cs342:set (forall (T) (-> (T ...) (set-of T))))

(defrep (forall (T) (set-of T) (list-of T)))

(define cs342:set-one-elem car)
(define cs342:set-rest cdr)
(define cs342:set-empty? null?)

(define cs342:set-member?
  (lambda (e S)
    (and (not (cs342:set-empty? S))
	 (or (equal? e (cs342:set-one-elem S))
	     (cs342:set-member? e (cdr S))))))

(define cs342:set-equal?
  (letrec
      ((set-subset?
	(has-type
	 (-> ((set-of T) (set-of T)) boolean)
	 (lambda (S1 S2)
	   (or (cs342:set-empty? S1)
	       (and (cs342:set-member? (cs342:set-one-elem S1) S2)
		    (set-subset? (cs342:set-rest S1) S2)))))))
    (lambda (S1 S2)
      (and (set-subset? S1 S2)
	   (set-subset? S2 S1)))))

(define cs342:left-protected-set-equal?
  (lambda (actual expected)
    (and (cs342:set? actual)
	 (cs342:set-equal? actual expected))))

(define cs342:no-duplicates?
  (lambda (ls)
    (or (null? ls)
	(and (not (member (car ls) (cdr ls)))
	     (cs342:no-duplicates? (cdr ls))))))

(define cs342:set?
  (lambda (x)
    (and (list? x) (cs342:no-duplicates? x))))

(define cs342:set
  (lambda args
    (if (null? args)
	'()
	(let ((rest (apply cs342:set (cdr args))))
	  (if (cs342:set-member? (car args) rest)
	      rest
	      (cons (car args) rest))))))

) ; end module
