;;; $Id: simple-arith-expr.scm,v 1.7 2005/02/17 16:29:22 leavens Exp $
;;;
;;; Helping procedures for the following grammar.
;;;   <simple-arith-expr> ::= <number>
;;;                       | (<op> <simple-arith-expr> <simple-arith-expr>)
;;;   <op> ::= + | - | *

(module simple-arith-expr (lib "typedscm.ss" "lib342")

(provide simple-arith-expr simple-arith-expr? parse-simple-arith-expr)

(deftype parse-simple-arith-expr (-> (datum) simple-arith-expr))

(define-datatype simple-arith-expr simple-arith-expr?
  (literal (number number?))
  (op-call (op symbol?)
	   (left-arg simple-arith-expr?)
	   (right-arg simple-arith-expr?)))

(define simple-arith-expr:permitted-ops
  '(+ - * /))

(define parse-simple-arith-expr
  (lambda (exp)
    (cond
     ((number? exp) (literal exp))
     ((and (list? exp)
	   (= (length exp) 3)
	   (memq (car exp) simple-arith-expr:permitted-ops))
      (op-call (car exp)
	       (parse-simple-arith-expr (cadr exp))
	       (parse-simple-arith-expr (caddr exp))))
     (else (error "parse-simple-arith-expr: bad syntax:" exp)))))

) ;; end module
