;;; $Id: sym-cell.tst,v 1.1 2005/02/17 19:43:43 leavens Exp $

(require (lib "sym-cell.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (sym-cell? (sym-cell 'x)) ==> #t )
    ( (sym-cell? 'x) ==> #f )

    ( (sym-cell-ref (sym-cell 'x)) = 'x )
    ( (sym-cell-ref (sym-cell 'x)) = 'x )
    ( (let* ((my-sym-cell (sym-cell 'y))
	     (old-val (sym-cell-ref my-sym-cell)))
	(sym-cell-set! my-sym-cell 'z)
	(list old-val (sym-cell-ref my-sym-cell)))
      ==> (y z) )

    ( (let* ((c1 (sym-cell 'x42))
	     (c2 (sym-cell 'y41))
	     (c1-old (sym-cell-ref c1))
	     (c2-old (sym-cell-ref c2)))
	(sym-cell-swap! c1 c2)
	(list c1-old c2-old (sym-cell-ref c1) (sym-cell-ref c2)))
      ==> (x42 y41 y41 x42) )

    )
 )

