;; $Id: tc-attrib-pair.scm,v 1.1 2005/03/04 06:56:54 leavens Exp $

;; AUTHOR: Brian Dorn and Gary T. Leavens

;;         ATTRIBUTED SYNTAX PAIRS      
;; 
;; Attributed syntax pairs are a pair
;; that contains a piece of syntax and some kind of attribute.
;; The : is the constructor for such pairs.

(module tc-attrib-pair (lib "typedscm.ss" "lib342")

(provide tc:attrib-pair-of : tc:attrib-pair->syn tc:attrib-pair->type
         ;; all-from tc-tree.scm
         tc:tree-of tc:root tc:leaves tc:node 
         tc:print-map tc:tree-print)

(deftype tc:attrib-pair-of (type-predicate-for tc:attrib-pair))
(deftype : (forall (syn attr) (-> (syn attr) (tc:attrib-pair-of syn attr))))
(deftype tc:attrib-pair->syn (forall (syn attr)
			 (-> (tc:attrib-pair-of syn attr) syn)))
(deftype tc:attrib-pair->type (forall (syn attr)
			  (-> (tc:attrib-pair-of syn attr) attr)))

(require (lib "tc-tree.scm" "lib342"))

(defrep
  (forall (syn attrib) (tc:attrib-pair-of syn attrib) (pair-of syn attrib)))

(define tc:attrib-pair-of
  (forall (Syn? Attr?) (pair-of Syn? Attr?)))

(define : 
  (lambda (syn attr)
    (cons syn attr)))

(define tc:attrib-pair->syn
  (lambda (asp)
    (car asp)))

(define tc:attrib-pair->type
  (lambda (asp)
    (cdr asp)))  

) ;; end module
