;;; $Id: tc-char-seq-as-list.scm,v 1.1 2005/02/28 06:58:05 leavens Exp $
;;; Character sequences, represented by lists, which are helpful for debugging.

(module tc-char-seq-as-list (lib "typedscm.ss" "lib342")
  
(provide tc:char-seq? tc:the-null-char-seq tc:char-seq-null?
         tc:make-char-seq tc:char-seq-head tc:char-seq-tail 
         tc:string->char-seq tc:stream->char-seq)
  
(deftype tc:char-seq? (type-predicate-for tc:char-seq))
(deftype tc:the-null-char-seq (-> () tc:char-seq))
(deftype tc:char-seq-null? (-> (tc:char-seq) boolean))
(deftype tc:make-char-seq (-> (char tc:char-seq) tc:char-seq))
(deftype tc:char-seq-head (-> (tc:char-seq) char))
(deftype tc:char-seq-tail (-> (tc:char-seq) tc:char-seq))
(deftype tc:string->char-seq (-> (string) tc:char-seq))
(deftype tc:stream->char-seq (-> ((tc:stream char)) tc:char-seq))

(require (lib "tc-parsing-stream.scm" "lib342"))

(defrep (tc:char-seq (list-of char)))

(define tc:char-seq?
  (lambda (d)
    ((list-of char?) d)))

(define tc:the-null-char-seq
  (lambda ()
    '()))

(define tc:char-seq-null?
  (lambda (cs)
    (null? cs)))

(define tc:make-char-seq
  (lambda (c cs)
    (cons c cs)))

(define tc:char-seq-head
  (lambda (cs)
    (car cs)))

(define tc:char-seq-tail
  (lambda (cs)
    (cdr cs)))

(define tc:string->char-seq
  (lambda (str)
    (string->list str)))

(define tc:stream->char-seq
  (lambda (stream)
    (let ((cls '()))
      (tc:stream-for-each
       (lambda (c)
	 (set! cls (cons c cls)))
       stream)
      (reverse cls))))
)
