;;; $Id: tc-char-seq-as-stream.scm,v 1.1 2005/02/28 06:58:05 leavens Exp $
;;; Character sequences, represented by streams

(module tc-char-seq-as-stream (lib "typedscm.ss" "lib342")
  
(provide tc:char-seq? tc:the-null-char-seq tc:char-seq-null?
         tc:make-char-seq tc:char-seq-head tc:char-seq-tail 
         tc:string->char-seq tc:stream->char-seq)

(deftype tc:char-seq? (type-predicate-for tc:char-seq))
(deftype tc:the-null-char-seq (-> () tc:char-seq))
(deftype tc:char-seq-null? (-> (tc:char-seq) boolean))
(deftype tc:make-char-seq (-> (char tc:char-seq) tc:char-seq))
(deftype tc:char-seq-head (-> (tc:char-seq) char))
(deftype tc:char-seq-tail (-> (tc:char-seq) tc:char-seq))
(deftype tc:string->char-seq (-> (string) tc:char-seq))
(deftype tc:stream->char-seq (-> ((tc:stream char)) tc:char-seq))

(require (lib "tc-parsing-stream.scm" "lib342"))

(defrep (tc:char-seq (tc:stream char)))

(define tc:char-seq?
  (lambda (d)
    ((tc:stream-of char?) d)))

(define tc:the-null-char-seq
  (lambda ()
    (tc:the-null-stream)))

(define tc:char-seq-null?
  (lambda (cs)
    (tc:stream-null? cs)))

(define tc:make-char-seq
  (lambda (ch seq)
    (tc:make-stream ch (lambda () seq))))

(define tc:char-seq-head
  (lambda (seq)
    (tc:stream-car seq)))

(define tc:char-seq-tail
  (lambda (seq)
    (tc:stream-cdr seq)))

(define tc:string->char-seq
  (lambda (str)
    (let ((len (string-length str)))
    (if (= 0 len)
	(tc:the-null-stream)
	(tc:make-stream
	 (string-ref str 0)
	 (lambda ()
	   (tc:string->char-seq (substring str 1 len))))))))

(define tc:stream->char-seq
  (lambda (stream)
    stream))
)
