;;; $Id: tc-global-var-types.scm,v 1.7 2005/03/12 20:15:02 leavens Exp $
;;; Types for built-in Scheme procedures for use with Brian Dorn's
;;; incarnation of the type-checker
;;; AUTHORS: Brian Dorn and Gary Leavens based on earlier work with
;;;          Curtis Clifton and Steven L. Jenkins.

(module tc-global-var-types (lib "typedscm.ss" "lib342")

(provide tc:global-var-types)

(deftype tc:global-var-types (-> () (tc:env-of symbol tc:type-expr)))
  
(require (lib "tc-global-var-output-types.scm" "lib342")
         (lib "tc-environments.scm" "lib342")
	 (lib "tc-type-translate.scm" "lib342"))

(deftype *tc:global-var-types* (tc:env-of symbol tc:type-expr))
(define *tc:global-var-types*
  (has-type-trusted
    (tc:env-of symbol tc:type-expr)
    #f))

(define tc:global-var-types
  (lambda ()
    (if (has-type-trusted boolean (not *tc:global-var-types*))
	(set! *tc:global-var-types*
	      (tc:env-map
	       (lambda (sym output-typ)
		 (tc:type-parse output-typ))
	       *tc:pre-global-var-output-type-env*)))
    *tc:global-var-types*))

) ;; end module
