;;; $Id: tc-scheme-token.scm,v 1.2 2005/03/02 01:48:50 leavens Exp $

(module tc-scheme-token (lib "typedscm.ss" "lib342")

(provide tc:scheme-token-record tc:scheme-token? tc:scheme-token
	 tc:scheme-token->data tc:scheme-token->position
	 tc:scheme-token->class tc:token-class->string
	 ;; all-from tc-position
	 tc:position tc:position? tc:make-token-position tc:make-tree-position
	 tc:position->start-line tc:position->end-line tc:position->filename
	 tc:position->error-string tc:position->error-lines-string
	 tc:current-scanner-position tc:current-line tc:new-line!
	 tc:current-input-filename
	 tc:start-input-filename! tc:end-input-filename!)

(require (lib "tc-position.scm" "lib342"))
  
(define-datatype tc:scheme-token-record tc:scheme-token?
  (tc:scheme-token (position tc:position?) (class symbol?) (data datum?)))

(deftype tc:scheme-token->data (-> (tc:scheme-token-record) datum))
(define tc:scheme-token->data
  (lambda (tok)
    (cases tc:scheme-token-record tok
	   (tc:scheme-token (position class data) data))))

(deftype tc:scheme-token->position (-> (tc:scheme-token-record) tc:position))
(define tc:scheme-token->position
  (lambda (tok)
    (cases tc:scheme-token-record tok
	   (tc:scheme-token (position class data) position))))

(deftype tc:scheme-token->class (-> (tc:scheme-token-record) symbol))
(define tc:scheme-token->class
  (lambda (tok)
    (cases tc:scheme-token-record tok
	   (tc:scheme-token (position class data) class))))

(deftype tc:token-class->string (-> (symbol) string))
(define tc:token-class->string
  (lambda (token-class)
    (case token-class
      ((lparen) "(")
      ((rparen) ")")
      ((dot) ".")
      ((end-marker) "<end of file>")
      ((quote-char) "'")
      ((quasiquote-char) "`")
      ((unquote-char) ",")
      ((unquote-splicing-char) ",@")
      ((sharp-lparen) "#(")
      ((number boolean string char symbol)
       (string-append "<" (symbol->string token-class) ">"))
      (else (symbol->string token-class)))))
)
