;;; $Id: tc-token-seq-as-stream.scm,v 1.1 2005/02/28 06:58:05 leavens Exp $
;;; Token sequences, represented by streams

(module tc-token-seq-as-stream (lib "typedscm.ss" "lib342")

(provide tc:token-seq? tc:the-null-token-seq tc:token-seq-null?
         tc:make-token-seq tc:make-token-seq-with-thunk
         tc:token-seq-head tc:token-seq-tail tc:token-seq-for-each
         ;; all-from tc-parsing-stream.scm
         tc:stream-of tc:stream-car tc:stream-cdr tc:make-stream
         tc:the-null-stream tc:stream-null? tc:stream-for-each
         tc:make-input-stream)

(deftype tc:token-seq? (type-predicate-for tc:token-seq))
(deftype tc:the-null-token-seq (-> () tc:token-seq))
(deftype tc:token-seq-null? (-> (tc:token-seq) boolean))
(deftype tc:make-token-seq (-> (tc:scheme-token tc:token-seq) tc:token-seq))
(deftype tc:make-token-seq-with-thunk
  (-> (tc:scheme-token (-> () tc:token-seq))
      tc:token-seq))
(deftype tc:token-seq-head (-> (tc:token-seq) tc:scheme-token))
(deftype tc:token-seq-tail (-> (tc:token-seq) tc:token-seq))
(deftype tc:token-seq-for-each
  (forall (T) (-> ((-> (T) void) tc:token-seq) void)))

(require (lib "tc-scheme-token.scm" "lib342")
	 (lib "tc-parsing-stream.scm" "lib342"))

(defrep (tc:token-seq (tc:stream tc:scheme-token)))

(define tc:token-seq?
  (lambda (obj)
    ((tc:stream-of tc:scheme-token?) obj)))

(define tc:the-null-token-seq
  (lambda ()
    (tc:the-null-stream)))

(define tc:token-seq-null?
  (lambda (ts)
    (tc:stream-null? ts)))

(define tc:make-token-seq
  (lambda (token seq)
    (tc:make-stream token (lambda () seq))))

(define tc:make-token-seq-with-thunk
  (lambda (t th)
    (tc:make-stream t th)))

(define tc:token-seq-head
  (lambda (ts)
    (tc:stream-car ts)))

(define tc:token-seq-tail
  (lambda (ts)
    (tc:stream-cdr ts)))

(define tc:token-seq-for-each
  (lambda (proc ts)
    (tc:stream-for-each proc ts)))
)
