;;; $Id: tc-tracing.scm,v 1.1 2005/03/12 16:53:08 leavens Exp $
;;; Tracing level for the type checker
;;; AUTHORS: Gary T. Leavens and Brian Dorn

;;;----------------------------------------------------------------------------
;;;
;;; An environment is an object that associates variables to values.

(module tc-tracing (lib "typedscm.ss" "lib342")

(provide type-tracing-set! type-tracing-off! type-tracing-level
	 tc:type-tracing-set!)

(define *tc:tracing-level* 0)

;;; The following set the level of tracing in the type checker
(deftype type-tracing-set! (-> (number) void))
(define type-tracing-set!
  (lambda (num)
    (tc:type-tracing-set! num)
    (if (> *tc:tracing-level* 0)
	(displayln "Typed interpreter verbose tracing is now on at level "
		   *tc:tracing-level*)
	(displayln "Typed interpreter verbose tracing is now off."))))

(deftype tc:type-tracing-set! (-> (number) void))
(define tc:type-tracing-set!
  (lambda (num)
    (set! *tc:tracing-level* num)))

;;; The following turns off tracing in the type checker
(deftype type-tracing-off! (-> () void))
(define type-tracing-off!
  (lambda ()
    (tc:type-tracing-set! 0)
    (displayln "Typed interpreter verbose tracing is now off.")))

;;; The following queries the status of the tracing level in the
;;; type checker.
(deftype type-tracing-level (-> () number))
(define type-tracing-level
  (lambda ()
    *tc:tracing-level*))

) ;; end module
