;; $Id: tc-tree.scm,v 1.8 2005/04/01 05:14:00 leavens Exp $

;; One way to do trees in Scheme

;; AUTHOR: Gary T. Leavens, Brian Dorn

(module tc-tree (lib "typedscm.ss" "lib342")

(provide tc:tree-of tc:root tc:leaves tc:node tc:print-map tc:tree-print)

(deftype tc:tree-of (forall (a)
		      (-> ((type-predicate-for a))
			  (type-predicate-for (tc:tree-of a)))))
(deftype tc:root (forall (a) (-> ((tc:tree-of a)) a)))
(deftype tc:leaves (forall (a) (-> ((tc:tree-of a))
				(list-of (tc:tree-of a)))))
(deftype tc:node (forall (a) (-> (a (list-of (tc:tree-of a))) (tc:tree-of a))))

(defrep (forall (a) (tc:tree-of a) (pair-of a (list-of (tc:tree-of a)))))

(define tc:tree-of
  (has-type-trusted
    (forall (a)
      (-> ((type-predicate-for a))
	  (type-predicate-for (tc:tree-of a))))
  (forall (elemtype?)
    (lambda (val)
      ((pair-of elemtype?
		(list-of (tc:tree-of elemtype?)))
       val)))))

(define tc:root
  (lambda (tree)
    (car tree)))

(define tc:leaves
  (lambda (tree)
    (cdr tree)))

(define tc:node
  (lambda (a as)
    (cons a as)))

(define tc:print-map
  (lambda (printer l)
    (if (not (null? l))
	(begin
	  (printer (car l))
	  (tc:print-map printer (cdr l))))))

(define tc:tree-print
  (lambda (tree)
    (tree-print-help tree "")))

(define tree-print-help
  (lambda (tree prefix)
    (displayln prefix "-" (tc:root tree))
    (leaf-print (tc:leaves tree) (string-append prefix " |"))))

(define leaf-print
  (lambda (ls prefix )
    (tc:print-map (lambda (t) (tree-print-help t prefix)) ls)))

) ;; end module
