;;; $Id: type-check-ignore-types-at-runtime.scm,v 1.19 2005/04/12 16:55:03 leavens Exp $
;;;
;;; Use this file if you aren't using the type checker but are working with
;;; Scheme files that have deftypes and defreps in them

;;; The following are R5RS macros.

(define-syntax has-type
    (syntax-rules ()
      ((has-type type-exp expression)
       expression)))

(define-syntax has-type-trusted
    (syntax-rules ()
      ((has-type-trusted type-exp expression)
       expression)))

;; The <- procedure is defined in type-predicates.scm
(define-syntax ->
  (syntax-rules ()
    ((-> (argument-predicate ...) result-predicate)
     (<- result-predicate argument-predicate ...))))

(define-syntax forall
  (syntax-rules ()
    ((forall type-predicate-formals predicate-expression)
     (lambda type-predicate-formals predicate-expression))))

;; The following relies on syntax-case and generate-temporaries.
;; These are supposed to be in both MzScheme and Chez Scheme.
;; See below if these don't work for you.
;; However, the more complex translation is preferred, as it makes
;; deftype be a definition form.
(define-syntax deftype
  (lambda (x)
    (syntax-case x ()
      ((deftype name type-exp)
       (with-syntax (((gname) (generate-temporaries (syntax (name)))))
	  (syntax (define gname #f)))))))

;; Use the following if you can't get the above definition of deftype to work
;; in your Scheme system.
; (define-syntax deftype
;   (syntax-rules ()
;     ((deftype name type-exp)
;      (void)))) ; should be a definition form, technically

(define-syntax defrep
  (syntax-rules (forall)
    ((defrep (forall (type-var ...) abstract-type concrete-type))
     (begin))
    ((defrep (abstract-type concrete-type))
     (begin))
    ;; old syntax, shouldn't be used anymore
    ((defrep abstract-type concrete-type)
     (begin))
    ((defrep (forall (type-var ...) abstract-type concrete-type)
       abs-conc-pair ...)
     (defrep abs-conc-pair ...))
    ((defrep (abstract-type concrete-type) abs-conc-pair ...)
     (defrep abs-conc-pair ...))
    ))

;; old syntax, shouldn't be used anymore
(define-syntax public
  (syntax-rules ()
    ((public name ...)
     (begin))))

;; old syntax, shouldn't be used anymore
(define trustme! (void))

(load-quietly-from-lib "type-predicates.scm")
