;;; $Id: typedscm.ss,v 1.8 2005/03/30 04:40:31 leavens Exp $
;;; Typedscm language for use in Com S 342,
;;; for the 342 language (typedscm).

(module typedscm mzscheme
 
  (provide (all-from (lib "localize.scm" "lib342")))
  (provide (all-from (lib "load-from-lib.scm" "lib342")))
  (provide (rename load std:load))
  (provide (rename load-loudly load))
  (provide displayln quit force-output exit random void promise? file-exists?)
  ;; The following are used in slib.init (from MzScheme)
;  (provide build-path collection-path unless system-type
;           namespace-require version getenv with-handlers
;           current-seconds print-vector-length add1 sub1)
  (provide (all-from (lib "test-homework.scm" "lib342")))
  (provide (all-from
	    (lib "type-check-ignore-types-at-runtime.scm" "lib342" "drscheme")))
  (provide (rename typedscm-void? void?))
  (provide (all-from-except (lib "eopl.ss" "eopl")
                            eopl:define eopl:module-begin
			    eopl:call-with-current-continuation
                            list-of))
  (provide (rename eopl:pretty-print pretty-print))
  (provide (rename eopl:error error))
  (provide (rename eopl:define define))
  (provide (rename eopl:module-begin #%module-begin))
  (provide (rename eopl:call-with-current-continuation
                   call-with-current-continuation))
  ;; values in eopl.ss, from R5RS
  (provide car cdr caar cadr cdar cddr
	   caaar caadr cadar caddr cdaar cdadr cddar cdddr
	   caaaar caaadr caadar caaddr cadaar cadadr caddar cadddr
	   cdaaar cdaadr cdadar cdaddr cddaar cddadr cdddar cddddr
	   map = < > <= >= max min + - * / 
	   abs gcd lcm exp log sin cos tan not eq?
	   make-string
	   symbol->string string->symbol make-rectangular 
	   exact->inexact inexact->exact number->string string->number 
	   rationalize output-port? current-input-port current-output-port
	   current-error-port 
	   open-input-file open-output-file close-input-port close-output-port
	   with-output-to-file transcript-on transcript-off flush-output
	   string-length string-ci<=? string-ci>=? string-append 
	   string->list list->string string-fill! 
	   vector-length vector->list list->vector vector-fill!
	   char-alphabetic? char-numeric? char-whitespace? 
	   char-upper-case? char-lower-case? char->integer integer->char
	   char-downcase
	   call-with-output-file call-with-input-file with-input-from-file
	   apply for-each symbol? pair? cons set-car! set-cdr! null?
	   list? list length append reverse
	   list-tail list-ref memq memv member assq assv assoc procedure?
	   number? complex? real? rational? integer? exact? inexact? zero?
	   positive?  negative? odd? even? 
	   quotient remainder modulo floor ceiling truncate round 
	   numerator denominator asin acos atan sqrt
	   expt make-polar real-part imag-part angle magnitude input-port?
	   read read-char peek-char eof-object?
	   char-ready? write display newline write-char 
	   string? string string-ref string-set! string=? substring string-copy
	   string-ci=? string<? string>? string<=? string>=? string-ci<?
	   string-ci>?
	   vector? make-vector vector vector-ref vector-set! 
	   char? char=? char<? char>? char<=? char>=? 
	   char-ci=? char-ci<? char-ci>? char-ci<=? char-ci>=? 
	   char-upcase boolean? eqv? equal? force
	   call-with-values values eval port? scheme-report-environment
	   null-environment 
	   interaction-environment dynamic-wind)
  (provide quasiquote unquote unquote-splicing 
	   if let and or cond case delay do
	   letrec let* begin lambda quote set!
	   define-syntax syntax-rules letrec-syntax let-syntax
           #%app #%datum #%top)
  (provide time            ;; useful to compare implementations
	   collect-garbage ;; useful with `time'
           require require-for-syntax  ;; we allow full use of modules
	   module provide)             ;; in case someone wants to use a module


  ;; Edit the file localize.scm to say where you put the course library
  ;; (from lib342.zip), etc.
  (require (lib "localize.scm" "lib342"))
  (require (lib "load-from-lib.scm" "lib342"))
  
  ;; standardization of DrScheme for typedscm
  ;; You shouldn't need to change the following...
 
  (require (lib "displayln.scm" "lib342"))
  
  ;; Some other things to make DrScheme more like SCM
  (print-vector-length #f)
  (define quit exit)
  (define force-output void)
  
  (require (all-except (lib "eopl.ss" "eopl")
                       define #%module-begin call-with-current-continuation
                       list-of))
  (require (rename (lib "eopl.ss" "eopl") eopl:define define))
  (require (rename (lib "eopl.ss" "eopl") eopl:module-begin #%module-begin))
  (require (rename (lib "eopl.ss" "eopl")
                   eopl:call-with-current-continuation
                   call-with-current-continuation))

  (require (lib "test-homework.scm" "lib342"))
  (require (lib "type-check-ignore-types-at-runtime.scm" "lib342" "drscheme"))
  )
